SystemOrganization addCategory: #'A4BP-Spy'!
SystemOrganization addCategory: 'A4BP-Spy-Core'!
SystemOrganization addCategory: 'A4BP-Spy-Core-Counting'!
SystemOrganization addCategory: 'A4BP-Spy-Core-Hapao2'!
SystemOrganization addCategory: 'A4BP-Spy-Core-Performance'!
SystemOrganization addCategory: 'A4BP-Spy-Core-Temporal'!
SystemOrganization addCategory: 'A4BP-Spy-Instrumentation'!
SystemOrganization addCategory: 'A4BP-Spy-Integration'!
SystemOrganization addCategory: 'A4BP-Spy-SOA-Integration'!
SystemOrganization addCategory: 'A4BP-Spy-View'!
SystemOrganization addCategory: 'A4BP-Spy-View-Action'!
SystemOrganization addCategory: 'A4BP-Spy-View-Model'!
SystemOrganization addCategory: 'A4BP-Spy-Visualization'!

!A4BPUIMainModel methodsFor: '*A4BP-Spy-View-UI' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 17:47'!
displaySpyElements
	^ BPSpyInstanceController instance! !

BPGenericType subclass: #BPInstrumentationType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Instrumentation'!

!BPInstrumentationType commentStamp: '<historical>' prior: 0!
A BPInstrumentationType is xxxxxxxxx.
!

!BPInstrumentationType class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 7/28/2014 01:35'!
findType: aBPObject
	^ aBPObject myDocument name ! !

!BPInstrumentationType class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 7/28/2014 02:33'!
newGenericType: aBPObject
	| bpVT array |
	bpVT := self new.	"find the namespace of the definition"
	array := (self findType: aBPObject) subStrings: ':'.
	array size > 1
		ifTrue: [ 
				bpVT prefix: (array at: 1).
				bpVT element: (array at: 2).
				bpVT findNameSpace: aBPObject.
		];
		ifFalse: [ bpVT element: (array at: 1) ].
	
	^ bpVT! !

!BPInstrumentationType methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 7/28/2014 02:39'!
findNameSpace: aBPObject
	| ns |
	ns := ''.
	[ ns := aBPObject myDocument nameSpaces at: self prefix ]
		on: KeyNotFound
		do: [  ].
	nameSpace := ns.
	^ ns! !

!BPInstrumentationType methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 22:33'!
ns
	^ self nsForInstrumentation! !

!BPInstrumentationType methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 7/28/2014 02:40'!
nsForInstrumentation
	"I hope that gt is an instance of BPInstrumentationType"
	prefix ifNil:[ ^ ''].
	^ 'xmlns:', prefix ,'="', nameSpace ,'" '! !

!BPInstrumentationType methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 7/31/2014 09:38'!
pf
	^ self prefixForInstrumentation! !

!BPInstrumentationType methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 7/28/2014 02:15'!
prefixForInstrumentation
	"for instrumentation we need print <tags> aditional into process
	if the process have a prefix like <bpel:process> then this method
	return the bpel: else if the prefix is empty like <process> then 
	this mehtod return ''"
	
	prefix ifNil:[ ^ ''].
	^ prefix,':'! !

!BPInstrumentationType methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 7/31/2014 09:42'!
tizq
	^ '<' , self pf! !

A4BPUIGLMActionTreeBuilderVisitor subclass: #A4BPSpyUIGLMRClick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-View-Action'!

!A4BPSpyUIGLMRClick class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:20'!
annotation
<MSEClass: #A4BPSpyUIGLMRClick  super: #A4BPUIGLMActionTreeBuilderVisitor >
<package: #'A4BP-Spy' >! !

!A4BPSpyUIGLMRClick methodsFor: 'model-a4bp' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:40'!
visitA4BPSOAContext: aModel
	| actions act |
	actions := OrderedCollection new.	
	"Delete Element"
	act := GLMGenericAction new
		action: [ :b | 
					A4BPSOAAnalyzer instance deleteSOAContext: aModel.
					b update ];
		title: A4BPUII18n msg msgDelete.
	actions add: act.
	^ actions! !

!A4BPSpyUIGLMRClick methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:41'!
visitBPProcess: aModel
	|actions act|
	actions:= self actionBasicBrowser:aModel.
	"Instrumentation Element"
	act:=GLMGenericAction new 
	action:[:b| 
		|v|
		A4BPLog d:'v := BPSpyFullInstrumenter new.'.
		v := BPSpyFullInstrumenter new.
		A4BPLog d:'v buildInstrumentation: aModel.'.
		v buildInstrumentation: aModel.
		A4BPLog d:'b update.'.
		b update.
	];
	category:A4BPUII18n msg msgInstrumentate;
	title:A4BPUII18n msg msgInstrumentate.
	actions add:act.
	^ actions.! !

A4BPUIGLMBuilder subclass: #BPUISpyViewNavigator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-View'!

!BPUISpyViewNavigator methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 17:43'!
buildBrowser
	|browser|
	browser := GLMTabulator new.
	browser := GLMTabulator new.	"add the column in a glamour browser"
	browser title: A4BPUII18n msg msgSOAAnalyzerPanel.
	browser
		column: #allSpyInstance;
		column: #SpyView span:6.	"set what information must be to show"
	browser transmit
		to: #allSpyInstance;
		andShow: [ :a | self displayAllSpyInstance: a ].
	browser transmit
		to: #SpyView;
		from: #allSpyInstance;
		andShow: [ :a | self displaySpyView: a ].
	^ browser! !

!BPUISpyViewNavigator methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 17:54'!
buildBrowserIn: browser
	|tabulator|
	tabulator := browser tabulator.
	tabulator title:'Spy'.
	tabulator
		column: #allSpyInstance;
		column: #SpyView span:6.	"set what information must be to show"
	tabulator transmit
		to: #allSpyInstance;
		andShow: [ :a | self displayAllSpyInstance: a ].
	tabulator transmit
		to: #SpyView;
		from: #allSpyInstance;
		andShow: [ :a | self displaySpyView: a ].
	^ browser! !

!BPUISpyViewNavigator methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/22/2015 08:51'!
childrenOf: rootPackage on: organizer
	rootPackage ifNotNil: [ ^ rootPackage getChildrenNodes ].
	^ A4BPEmptyObj instance getChildrenNodes! !

!BPUISpyViewNavigator methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 17:48'!
displayAllSpyInstance: a
	|actiontreev|
	actiontreev:=BPUIGLMActionSpyMainTreeBuilderVisitor new.
	a tree
		title: A4BPUII18n msg msgSOAModels;
		display: [ :org | 
			"A4BPUIMainModel>>displaySpyElements"
			org displaySpyElements ];
		children: [ :rootPackage :org | self childrenOf: rootPackage on: org ];
		"icon: [ :x | BPUIBPModelIconBuilderVisitor icon: x ];"
		dynamicActionsOnSelection: [ :list :v | list selection accept:actiontreev];
		format: #label.
	^ a
! !

!BPUISpyViewNavigator methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 11:44'!
displaySpyView: a
	| glm |
	glm := a tabulator.
	glm title: 'v'.
	glm
		column: #lstOfVisualization;
		column: #theview span:4.
	glm transmit
		to: #lstOfVisualization;
		andShow: [ :aa | self displaylstOfVisualizationIn: aa ].
	glm transmit
		to: #theview;
		from: #lstOfVisualization;
		andShow: [ :glmc :viewBuilder | 
					(glmc ~= nil and: viewBuilder ~= nil)
						ifTrue: [ viewBuilder executeVisualizationOnGLMC: glmc ] ]	"glmc-> glamourComposite"! !

!BPUISpyViewNavigator methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 11:45'!
displaylstOfVisualizationIn: constructor
" show as a list the visualization available in the BPVCBuilder list depent of object model selected"
	| aBPVCBuilder |
	aBPVCBuilder := BPSpyVCBuilder new.
	constructor list
		title: A4BPUII18n msg  msgVisualization;
		display: [ :org | 
					| dis |
					org class = LinkedList
						ifTrue: [ dis := org first];
						ifFalse: [ dis := org ].
					dis accept: aBPVCBuilder ];
		format: #name.
	^ constructor! !

!BPUISpyViewNavigator methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 17:44'!
open: model
	|browser|
	browser := self buildBrowser.
	(browser openOn: model) maximize! !

A4BPAbstractVisitor subclass: #BPSpyAbstractInstrumenter
	instanceVariableNames: 'bpWriterXML'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Instrumentation'!

!BPSpyAbstractInstrumenter commentStamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:25' prior: 0!
A BPAbstractInstrumenter is base visitor process to visit all component in bpel to add coberage.
!

!BPSpyAbstractInstrumenter class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:20'!
annotation
<MSEClass: #BPSpyAbstractInstrumenter  super: #A4BPAbstractVisitor >
<package: #'A4BP-Spy' >! !

!BPSpyAbstractInstrumenter methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 11:00'!
initialize
	super initialize.
	bpWriterXML := A4BPFactoryXMLParser parser.! !

!BPSpyAbstractInstrumenter methodsFor: 'visitor-BPEL-ActivityComposite' stamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:37'!
visitBPActivityComposite: aModel
	^ aModel getChildrenNodes do: [ :n | n accept: self ]! !

!BPSpyAbstractInstrumenter methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:30'!
visitBPBPELObject: aModel
	^ self visitBPObject: aModel! !

!BPSpyAbstractInstrumenter methodsFor: 'visitor-BPEL-ActivityComposite' stamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:34'!
visitBPFlow: aModel
	^ self visitBPActivityComposite: aModel! !

!BPSpyAbstractInstrumenter methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:30'!
visitBPObject: aBPObject
	^ 0! !

!BPSpyAbstractInstrumenter methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:28'!
visitBPProcess: aModel
	^ self visitBPBPELObject: aModel! !

!BPSpyAbstractInstrumenter methodsFor: 'visitor-BPEL-ActivityComposite' stamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:35'!
visitBPRepeatUntil: aModel
	^ self visitBPActivityComposite: aModel! !

!BPSpyAbstractInstrumenter methodsFor: 'visitor-BPEL-ActivityComposite' stamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:35'!
visitBPScope: aModel
	^ self visitBPActivityComposite: aModel! !

!BPSpyAbstractInstrumenter methodsFor: 'visitor-BPEL-ActivityComposite' stamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:34'!
visitBPSequence: aModel
	^ self visitBPActivityComposite: aModel! !

!BPSpyAbstractInstrumenter methodsFor: 'visitor-BPEL-ActivityComposite' stamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:35'!
visitBPWhile: aModel
	^ self visitBPActivityComposite: aModel! !

BPSpyAbstractInstrumenter subclass: #BPSpyFullInstrumenter
	instanceVariableNames: 'firstActivity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Instrumentation'!

!BPSpyFullInstrumenter commentStamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:25' prior: 0!
A BPAbstractInstrumenter is base visitor process to visit all component in bpel to add coberage.
!

!BPSpyFullInstrumenter class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:20'!
annotation
<MSEClass: #BPSpyFullInstrumenter  super: #BPSpyAbstractInstrumenter >
<package: #'A4BP-Spy' >! !

!BPSpyFullInstrumenter methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 09:35'!
bpWriterXML
	^ bpWriterXML! !

!BPSpyFullInstrumenter methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 09:11'!
bpWriterXML: aWriter
	bpWriterXML := aWriter ! !

!BPSpyFullInstrumenter methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 11:01'!
buildInstrumentation: aModel
	| obj bpelParser bpProcessInstrumented |
	A4BPLog d:'[INIT] build instrumentation'.
	"do the instrumentation process"
	obj := aModel accept: self.	
	"after the instrumentation process parse the new bpel"
	bpelParser := BPBPELParser new.
	bpelParser parseString: bpWriterXML fullPrintString.
	bpProcessInstrumented := bpelParser processes first.
	bpProcessInstrumented  fileName: aModel fileName.
	bpProcessInstrumented  fullPath: aModel fullPath. 
	bpProcessInstrumented aName: '{' , bpProcessInstrumented aName , '}'.
	aModel addInstrumentedProcess: bpProcessInstrumented.
	bpProcessInstrumented saveInDisk.
	self saveWSDlNearBPProcess: bpProcessInstrumented.
	A4BPLog d:'[END] build instrumentation'.
	^ bpWriterXML! !

!BPSpyFullInstrumenter methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 10:34'!
isBasicNode: n
	| s pl v |
	s := (BPBPELParserTagsXMLRef isTagSequence: n name) not.
	pl := (BPBPELParserTagsXMLRef isTagPartnerLinks: n name) not.
	v := (BPBPELParserTagsXMLRef isTagVariables: n name) not.
	^ (s and: pl) and: v! !

!BPSpyFullInstrumenter methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 15:57'!
saveWSDlNearBPProcess: aBPProcess
	aBPProcess fullPath
		ifNotNil: [ 
			| aStream pPath bPath wsSOA working|
			pPath := aBPProcess fullPath.
			bPath := pPath copyFrom: 1 to: (pPath lastIndexOf: FileSeparator cseparator).
			wsSOA := BPWSSOAInstrumentation new.
			working:=bPath asFileReference.
			aStream:= (working / wsSOA wsdlName) writeStream.
			aStream nextPutAll: wsSOA wsdl.
			aStream close ]! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 12:59'!
visitBBPWait: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML ! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 20:02'!
visitBPActivityBasic: aModel
	^ self writeAroundInCompositeActivity: aModel On: bpWriterXML! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Composite' stamp: 'AlvaroJosePeraltaOcampo 8/2/2014 13:06'!
visitBPActivityComposite: aModel
	| document |
	document := aModel myDocument.	
	"When the activity is the root only write their childrens"
	aModel parent = aModel myProcess
		ifTrue: [ 
			self writeFirstActivity: aModel On: bpWriterXML.
			^ self ].
	self writeAroundInCompositeActivity: aModel On: bpWriterXML.
	^ bpWriterXML! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 13:00'!
visitBPAssign: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML ! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:39'!
visitBPBPELObject: aModel
	^ self visitBPObject: aModel! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 13:00'!
visitBPCatch: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 13:00'!
visitBPCatchAll: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML ! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 13:01'!
visitBPElseIf: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML ! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 13:01'!
visitBPEmpty: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML ! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 13:01'!
visitBPExit: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML ! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Composite' stamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:39'!
visitBPFlow: aModel
	^ self visitBPActivityComposite: aModel! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 19:54'!
visitBPInvoke: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 12:51'!
visitBPObject: aModel
	! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 8/1/2014 17:23'!
visitBPProcess: aModel
	|tagWriter document|
	document := aModel myDocument.
	bpWriterXML := XMLWriter new.
	tagWriter := document writeWithOutChildrenOn: bpWriterXML.
	self writeNameSpaces: tagWriter. 
	tagWriter with:[
		"This is the basic content of the process with out activities"
		self writeImports:aModel inDoc:document.
		"write partnerLinks"
		self writePartnerLinks: aModel inDoc:document.
		"write variables"
		self writeVariables: aModel inDoc:document.
		aModel activities do: [ :n | n accept: self ].	
	].
	^ aModel.! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 8/2/2014 13:09'!
visitBPReceive: aModel
	firstActivity
		ifNil: [ 
			firstActivity = aModel.
			self writeActivityOnly: aModel On: bpWriterXML.
			self writeInitializeVariable: aModel On: bpWriterXML.
			self writeAfterIn: aModel On: bpWriterXML.
			^ bpWriterXML
		].
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Composite' stamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:39'!
visitBPRepeatUntil: aModel
	^ self visitBPActivityComposite: aModel! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 13:01'!
visitBPReply: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML ! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 13:01'!
visitBPRethrow: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML ! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Composite' stamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:39'!
visitBPScope: aModel
	^ self visitBPActivityComposite: aModel! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Composite' stamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:39'!
visitBPSequence: aModel
	^ self visitBPActivityComposite: aModel! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 13:01'!
visitBPThrow: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML ! !

!BPSpyFullInstrumenter methodsFor: 'visitor-BPEL-Activity-Composite' stamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:39'!
visitBPWhile: aModel
	^ self visitBPActivityComposite: aModel! !

!BPSpyFullInstrumenter methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 7/27/2014 00:48'!
writeActivityOnly: aModel On: aWriter
	|tagWriter document|
	document := aModel myDocument.
	tagWriter := document writeOn: aWriter.		! !

!BPSpyFullInstrumenter methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 13:46'!
writeAfterIn: aModel On: aWriter
	| maker  |
	maker := BPSpyMakerSimpleAfter new.
	maker buildXml: aModel.
	maker writeOn: aWriter.! !

!BPSpyFullInstrumenter methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 12:51'!
writeAroundInBasicActivity: aModel On: aWriter
	|tagWriter document|
	document := aModel myDocument.
	self writeBeforeIn: aModel On: aWriter.
	tagWriter := document writeOn: aWriter.		
	self writeAfterIn: aModel On: aWriter.! !

!BPSpyFullInstrumenter methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 12:53'!
writeAroundInCompositeActivity: aModel On: aWriter
	|tagWriter document|
		
	document := aModel myDocument.
	
	self writeBeforeIn: aModel On: aWriter.
	tagWriter := document writeWithOutChildrenOn: aWriter.		
	tagWriter with:[aModel getChildrenNodes do: [ :n | n accept: self ]].

	self writeAfterIn: aModel On: aWriter.! !

!BPSpyFullInstrumenter methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 7/28/2014 02:56'!
writeBasicNodes: document
	document nodes
		do: [ :n | 
			(self isBasicNode: n)
				ifTrue: [ n writeOn: bpWriterXML ] ]! !

!BPSpyFullInstrumenter methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 13:46'!
writeBeforeIn: aModel On: aWriter
	|maker | 
	maker := BPSpyMakerSimpleBefore new.
	maker buildXml: aModel.
	maker writeOn: aWriter.! !

!BPSpyFullInstrumenter methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 8/2/2014 13:05'!
writeFirstActivity: aModel On: aWriter
	| document tagWriter |
	document := aModel myDocument.	
	tagWriter := document writeWithOutChildrenOn: aWriter.
	tagWriter with: [ aModel getChildrenNodes do: [ :n | n accept: self ] ].	
	^ bpWriterXML

! !

!BPSpyFullInstrumenter methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 10:34'!
writeImports:aModel inDoc:document
	| maker|
	document nodes
		do: [ :n | 
			(BPBPELParserTagsXMLRef isTagImport: n name)
				ifTrue: [ n writeOn: bpWriterXML.] 
		].
		
		"Write the import to reference the wsdl and partnert link info"
		maker := BPSpyMakerImport new.
		maker buildXml: aModel.
		maker writeOn: bpWriterXML ! !

!BPSpyFullInstrumenter methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 8/2/2014 13:15'!
writeInitializeVariable: aModel On: aWriter
	| maker  |
	maker := BPSpyMakerSimpleInitVariables new.
	maker buildXml: aModel.
	maker writeOn: aWriter.! !

!BPSpyFullInstrumenter methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 15:32'!
writeNameSpaces: aWriter
	aWriter xmlnsAt: 'a4bp' put: 'http://a4bp.com/instrumentationService'.! !

!BPSpyFullInstrumenter methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 10:34'!
writePartnerLinks: aModel inDoc:document
	document nodes
		do: [ :n | 
			(BPBPELParserTagsXMLRef isTagPartnerLinks: n name)
				ifTrue: [ 
					| tagW maker |
					tagW := n writeWithOutChildrenOn: bpWriterXML.
					tagW with:[
						"put all partnerlinks"
						n nodes do: [ :pl | pl writeOn: bpWriterXML ].	
						"put the partnerlink to connect with the instrumentator"
						maker := BPSpyMakerPartnerLink new.
						maker buildXml: aModel.
						maker writeOn: bpWriterXML 
					] 
				] 
		]! !

!BPSpyFullInstrumenter methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 10:34'!
writeVariables: aModel inDoc:document
	document nodes
		do: [ :n | 
			(BPBPELParserTagsXMLRef isTagVariables: n name)
				ifTrue: [ 
					| tagW maker |
					tagW := n writeWithOutChildrenOn: bpWriterXML.
					tagW with:[   
						"put all variables"
						n nodes do: [ :pl | pl writeOn: bpWriterXML ].	
						"put the variables to help the instrumentation message"
						maker := BPSpyMakerVariables new.
						maker buildXml: aModel.
						maker writeOn: bpWriterXML. 
					] 
				]
		]! !

BPSpyAbstractInstrumenter subclass: #BPVC
	instanceVariableNames: 'firstActivity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Instrumentation'!

!BPVC commentStamp: 'AlvaroJosePeraltaOcampo 11/5/2014 22:58' prior: 0!
A BPVC is a tool to build a new xml process with the instrumentation activity conected to the system.

Instance Variables
	firstActivity:		<Object>

firstActivity
	- xxxxx
!

!BPVC class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:20'!
annotation
<MSEClass: #BPVC  super: #BPSpyAbstractInstrumenter >
<package: #'A4BP-Spy' >! !

!BPVC methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
bpWriterXML
	^ bpWriterXML! !

!BPVC methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
bpWriterXML: aWriter
	bpWriterXML := aWriter ! !

!BPVC methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:34'!
buildInstrumentation: aModel
	| obj bpelParser bpProcessInstrumented |
	A4BPLog d:'[INIT] build instrumentation'.
	"do the instrumentation process"
	obj := aModel accept: self.	
	"after the instrumentation process parse the new bpel"
	bpelParser := BPBPELParser new.
	bpelParser parseString: bpWriterXML fullPrintString.
	bpProcessInstrumented := bpelParser processes first.
	bpProcessInstrumented  fileName: aModel fileName.
	bpProcessInstrumented  fullPath: aModel fullPath. 
	bpProcessInstrumented aName: '{' , bpProcessInstrumented aName , '}'.
	aModel addInstrumentedProcess: bpProcessInstrumented.
	bpProcessInstrumented saveInDisk.
	self saveWSDlNearBPProcess: bpProcessInstrumented.
	A4BPLog d:'[END] build instrumentation'.
	^ bpWriterXML! !

!BPVC methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 10:34'!
isBasicNode: n
	| s pl v |
	s := (BPBPELParserTagsXMLRef isTagSequence: n name) not.
	pl := (BPBPELParserTagsXMLRef isTagPartnerLinks: n name) not.
	v := (BPBPELParserTagsXMLRef isTagVariables: n name) not.
	^ (s and: pl) and: v! !

!BPVC methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
saveWSDlNearBPProcess: aBPProcess
	aBPProcess fullPath
		ifNotNil: [ 
			| aStream pPath bPath wsSOA working|
			pPath := aBPProcess fullPath.
			bPath := pPath copyFrom: 1 to: (pPath lastIndexOf: $\).
			wsSOA := BPWSSOAInstrumentation new.
			working:=bPath asFileReference.
			aStream:= (working / wsSOA wsdlName) writeStream.
			aStream nextPutAll: wsSOA wsdl.
			aStream close ]! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBBPWait: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML ! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPActivityBasic: aModel
	^ self writeAroundInCompositeActivity: aModel On: bpWriterXML! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Composite' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPActivityComposite: aModel
	| document |
	document := aModel myDocument.	
	"When the activity is the root only write their childrens"
	aModel parent = aModel myProcess
		ifTrue: [ 
			self writeFirstActivity: aModel On: bpWriterXML.
			^ self ].
	self writeAroundInCompositeActivity: aModel On: bpWriterXML.
	^ bpWriterXML! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPAssign: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML ! !

!BPVC methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPBPELObject: aModel
	^ self visitBPObject: aModel! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPCatch: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPCatchAll: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML ! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPElseIf: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML ! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPEmpty: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML ! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPExit: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML ! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Composite' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPFlow: aModel
	^ self visitBPActivityComposite: aModel! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPInvoke: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPObject: aModel
	! !

!BPVC methodsFor: 'visitor-BPEL' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPProcess: aModel
	|tagWriter document|
	document := aModel myDocument.
	bpWriterXML := XMLWriter new.
	tagWriter := document writeWithOutChildrenOn: bpWriterXML.
	self writeNameSpaces: tagWriter. 
	tagWriter with:[
		"This is the basic content of the process with out activities"
		self writeImports:aModel inDoc:document.
		"write partnerLinks"
		self writePartnerLinks: aModel inDoc:document.
		"write variables"
		self writeVariables: aModel inDoc:document.
		aModel activities do: [ :n | n accept: self ].	
	].
	^ aModel.! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPReceive: aModel
	firstActivity
		ifNil: [ 
			firstActivity = aModel.
			self writeActivityOnly: aModel On: bpWriterXML.
			self writeInitializeVariable: aModel On: bpWriterXML.
			self writeAfterIn: aModel On: bpWriterXML.
			^ bpWriterXML
		].
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Composite' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPRepeatUntil: aModel
	^ self visitBPActivityComposite: aModel! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPReply: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML ! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPRethrow: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML ! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Composite' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPScope: aModel
	^ self visitBPActivityComposite: aModel! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Composite' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPSequence: aModel
	^ self visitBPActivityComposite: aModel! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Basic' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPThrow: aModel
	^ self writeAroundInBasicActivity: aModel On: bpWriterXML ! !

!BPVC methodsFor: 'visitor-BPEL-Activity-Composite' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
visitBPWhile: aModel
	^ self visitBPActivityComposite: aModel! !

!BPVC methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
writeActivityOnly: aModel On: aWriter
	|tagWriter document|
	document := aModel myDocument.
	tagWriter := document writeOn: aWriter.		! !

!BPVC methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
writeAfterIn: aModel On: aWriter
	| maker  |
	maker := BPSpyMakerSimpleAfter new.
	maker buildXml: aModel.
	maker writeOn: aWriter.! !

!BPVC methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
writeAroundInBasicActivity: aModel On: aWriter
	|tagWriter document|
	document := aModel myDocument.
	self writeBeforeIn: aModel On: aWriter.
	tagWriter := document writeOn: aWriter.		
	self writeAfterIn: aModel On: aWriter.! !

!BPVC methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
writeAroundInCompositeActivity: aModel On: aWriter
	|tagWriter document|
		
	document := aModel myDocument.
	
	self writeBeforeIn: aModel On: aWriter.
	tagWriter := document writeWithOutChildrenOn: aWriter.		
	tagWriter with:[aModel getChildrenNodes do: [ :n | n accept: self ]].

	self writeAfterIn: aModel On: aWriter.! !

!BPVC methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
writeBasicNodes: document
	document nodes
		do: [ :n | 
			(self isBasicNode: n)
				ifTrue: [ n writeOn: bpWriterXML ] ]! !

!BPVC methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
writeBeforeIn: aModel On: aWriter
	|maker | 
	maker := BPSpyMakerSimpleBefore new.
	maker buildXml: aModel.
	maker writeOn: aWriter.! !

!BPVC methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
writeFirstActivity: aModel On: aWriter
	| document tagWriter |
	document := aModel myDocument.	
	tagWriter := document writeWithOutChildrenOn: aWriter.
	tagWriter with: [ aModel getChildrenNodes do: [ :n | n accept: self ] ].	
	^ bpWriterXML

! !

!BPVC methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 10:34'!
writeImports:aModel inDoc:document
	| maker|
	document nodes
		do: [ :n | 
			(BPBPELParserTagsXMLRef isTagImport: n name)
				ifTrue: [ n writeOn: bpWriterXML.] 
		].
		
		"Write the import to reference the wsdl and partnert link info"
		maker := BPSpyMakerImport new.
		maker buildXml: aModel.
		maker writeOn: bpWriterXML ! !

!BPVC methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
writeInitializeVariable: aModel On: aWriter
	| maker  |
	maker := BPSpyMakerSimpleInitVariables new.
	maker buildXml: aModel.
	maker writeOn: aWriter.! !

!BPVC methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 10/25/2014 12:20'!
writeNameSpaces:aWriter
	aWriter xmlnsAt: 'a4bp' put: 'http://a4bp.com/instrumentationService'.! !

!BPVC methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 10:34'!
writePartnerLinks: aModel inDoc:document
	document nodes
		do: [ :n | 
			(BPBPELParserTagsXMLRef isTagPartnerLinks: n name)
				ifTrue: [ 
					| tagW maker |
					tagW := n writeWithOutChildrenOn: bpWriterXML.
					tagW with:[
						"put all partnerlinks"
						n nodes do: [ :pl | pl writeOn: bpWriterXML ].	
						"put the partnerlink to connect with the instrumentator"
						maker := BPSpyMakerPartnerLink new.
						maker buildXml: aModel.
						maker writeOn: bpWriterXML 
					] 
				] 
		]! !

!BPVC methodsFor: 'instrumentation' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 10:34'!
writeVariables: aModel inDoc:document
	document nodes
		do: [ :n | 
			(BPBPELParserTagsXMLRef isTagVariables: n name)
				ifTrue: [ 
					| tagW maker |
					tagW := n writeWithOutChildrenOn: bpWriterXML.
					tagW with:[   
						"put all variables"
						n nodes do: [ :pl | pl writeOn: bpWriterXML ].	
						"put the variables to help the instrumentation message"
						maker := BPSpyMakerVariables new.
						maker buildXml: aModel.
						maker writeOn: bpWriterXML. 
					] 
				]
		]! !

TestCase subclass: #BPParserXMLIntegrationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Integration'!

!BPParserXMLIntegrationTest commentStamp: '<historical>' prior: 0!
A BPParserWSIntegrationTest is a test class for testing the behavior of BPParserWSIntegration!

!BPParserXMLIntegrationTest methodsFor: 'source' stamp: 'AlvaroJosePeraltaOcampo 8/2/2014 19:52'!
src_soapReq001
^ 
'<?xml version=''1.0'' encoding=''UTF-8''?>
<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/">
	<soapenv:Header>
	 <addr:To xmlns:addr="http://www.w3.org/2005/08/addressing">http://localhost:8089/a4bp/A4bpInstrServiceHttpSoap11Endpoint</addr:To><addr:Action xmlns:addr="http://www.w3.org/2005/08/addressing">urn:instrumentation</addr:Action><addr:ReplyTo xmlns:addr="http://www.w3.org/2005/08/addressing"><addr:Address>http://www.w3.org/2005/08/addressing/anonymous</addr:Address></addr:ReplyTo><addr:MessageID xmlns:addr="http://www.w3.org/2005/08/addressing">uuid:hqejbhcnphr9hmvop88pxk</addr:MessageID></soapenv:Header><soapenv:Body><a4bpReq xmlns="http://a4bp.com/instrumentationService" xmlns:ns="http://a4bp.com/instrumentationService" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
	<ns:request>/bpel:process/bpel:sequence/bpel:receive</ns:request>
	</a4bpReq></soapenv:Body></soapenv:Envelope>'! !

!BPParserXMLIntegrationTest methodsFor: 'test-parser' stamp: 'AlvaroJosePeraltaOcampo 4/23/2015 20:31'!
testparserString
	"| soapReq parser value lstNode node|
	soapReq := self src_soapReq001.
	parser:=	BPParserXMLIntegration parseString: soapReq.
	self assert: parser ~= nil.
	""<ns:request>/bpel:process/bpel:sequence/bpel:receive</ns:request>""
	lstNode:= parser allElementsNamed: 'request'.
	node:= lstNode first.
	value:= node contentString.
	self assert: '/bpel:process/bpel:sequence/bpel:receive' = value."
	
! !

Object subclass: #BPSpyBaseLauncher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-View'!

!BPSpyBaseLauncher commentStamp: 'AlvaroJosePeraltaOcampo 11/11/2014 17:18' prior: 0!
A BPSpyBaseLauncher class is a launcher of worl menu reference to help to launch the spy.
!

!BPSpyBaseLauncher class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcamop 5/11/2015 08:18'!
go
	BPUISpyViewNavigator new open: BPSpyInstanceController instance.! !

!BPSpyBaseLauncher class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 11:58'!
menuCommandOn: aBuilder
	<worldMenu>

	(aBuilder item: #'BpelAnalyzerSpy')
		order: 0.1; 
		parent: #A4BP;
		label: 'Spy';
		action:[ self go ]! !

Object subclass: #BPSpyInstanceController
	instanceVariableNames: 'lstSpyModels lstMsgIntegration lstMsgIntegrationError lstObservables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-View-Model'!

BPSpyInstanceController class
	instanceVariableNames: 'instance'!

!BPSpyInstanceController commentStamp: 'AlvaroJosePeraltaOcampo 11/4/2014 15:20' prior: 0!
A BPSpyInstanceController is integration model to produce the list of analysis of content.

Instance Variables
	lstMsgIntegration:		<Object>
	lstMsgIntegrationError:		<Object>
	lstObservables:		<Object>
	lstSpyModels:		<Object>

lstMsgIntegration
	- xxxxx

lstMsgIntegrationError
	- xxxxx

lstObservables
	- xxxxx

lstSpyModels
	- xxxxx
!

BPSpyInstanceController class
	instanceVariableNames: 'instance'!

!BPSpyInstanceController class methodsFor: 'cleanup' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 17:46'!
clean
	"self clean"
	instance := nil! !

!BPSpyInstanceController class methodsFor: 'instance' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 17:46'!
instance
	instance ifNil: [ instance := self new ].
	^ instance! !

!BPSpyInstanceController methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:48'!
accept: aVisitor
	^ aVisitor visitBPSpyInstanceController: self! !

!BPSpyInstanceController methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 20:41'!
addModel: aModel
	lstSpyModels at: aModel aName put: aModel! !

!BPSpyInstanceController methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:46'!
addObservables: aObservable
	lstObservables add: aObservable! !

!BPSpyInstanceController methodsFor: 'delete' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:47'!
delete: aModel
	lstObservables do:[ :o | o removeObserver: self].! !

!BPSpyInstanceController methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcamop 5/11/2015 08:18'!
displaySpyElements
	^ self lstSpyModels! !

!BPSpyInstanceController methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 14:05'!
getChildrenNodes
	^ lstSpyModels.! !

!BPSpyInstanceController methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:46'!
initialize
	super initialize.
	lstSpyModels := Dictionary new.
	lstMsgIntegration := OrderedCollection new.
	lstMsgIntegrationError := OrderedCollection new.
	lstObservables := OrderedCollection new.
	BPSpyListener instance addObserver: self! !

!BPSpyInstanceController methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 13:57'!
label
	^ 'List of spy model'! !

!BPSpyInstanceController methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 13:52'!
lstSpyModels
	^ lstSpyModels! !

!BPSpyInstanceController methodsFor: 'update' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 22:26'!
updateSpy: entity
	| document |
	BPLog d: 'INIT BPSpyInstanceController>>updateSpy: entity'.
	BPLog d: 'INIT document := BPParserXMLIntegration parseString: entity'.
	[
		document := BPParserXMLIntegration parseString: entity.
		BPLog d: 'INIT lstMsgIntegration add: entity.'.
		lstMsgIntegration add: entity.
		BPLog d: 'END lstMsgIntegration add: entity.'.
	] 
	on:Error do:[ :er | 
		BPLog d: 'ERROR [document := BPParserXMLIntegration parseString: entity.]->[',er asString,']'.
		BPLog d: 'INIT lstMsgIntegrationError add: entity.'.
		lstMsgIntegrationError add: entity.
		BPLog d: 'END lstMsgIntegrationError add: entity.'.
	].
	BPLog d: 'END document := BPParserXMLIntegration parseString: entity'.
	
	BPLog d: 'END BPSpyInstanceController>>updateSpy: entity'.! !

Object subclass: #BPSpyListener
	instanceVariableNames: 'lstObservers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Integration'!

BPSpyListener class
	instanceVariableNames: 'instance'!

!BPSpyListener commentStamp: '<historical>' prior: 0!
A BPSpyListener is xxxxxxxxx.

Instance Variables
	lstObservers:		<Object>

lstObservers
	- xxxxx
!

BPSpyListener class
	instanceVariableNames: 'instance'!

!BPSpyListener class methodsFor: 'clean' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 22:29'!
clean
	"self clean"
	instance := nil.! !

!BPSpyListener class methodsFor: 'singleton' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 21:18'!
instance
	instance ifNil: [ instance := self new ].
	^ instance! !

!BPSpyListener methodsFor: 'observer' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:44'!
addObserver: aObserver
	lstObservers at: aObserver hash asString put: aObserver.
	aObserver addObservables: self! !

!BPSpyListener methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 23:10'!
initialize
	super initialize.
	lstObservers := Dictionary new! !

!BPSpyListener methodsFor: 'observer' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 05:05'!
notifyToAllListener:entity
	BPLog d: 'INIT BPSpyListener>>notifyToAllListener:entity'.
	lstObservers do:[ :o | 
		BPLog d: ('INIT (',o asString,') updateSpy: entity').
		o updateSpy: entity.
		BPLog d: ('END (',o asString,') updateSpy: entity').
		]. 
	BPLog d: 'END BPSpyListener>>notifyToAllListener:entity'.! !

!BPSpyListener methodsFor: 'observer' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 23:12'!
removeObserver: aObserver
	lstObservers removeKey: aObserver hash asString! !

Object subclass: #BPSpyMaker
	instanceVariableNames: 'lstMakers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Instrumentation'!

!BPSpyMaker commentStamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:43' prior: 0!
A BPSpyMaker is simple class that contain peace of code to inyect in the instrumentation.
!

!BPSpyMaker methodsFor: 'initilization' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 14:00'!
initialize
	super initialize.
	lstMakers := OrderedCollection new.! !

!BPSpyMaker methodsFor: 'to' stamp: 'AlvaroJosePeraltaOcampo 7/21/2014 13:36'!
toDocument
	^ BPFactoryXMLParser parser parse: (ReadStream on: self toXML)! !

!BPSpyMaker methodsFor: 'to' stamp: 'AlvaroJosePeraltaOcampo 7/19/2014 17:50'!
toXML
	^ ''! !

!BPSpyMaker methodsFor: 'writer' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 15:46'!
writeOn: aWriter
	lstMakers
		do: [ :m | 
			| document |
			document := A4BPFactoryXMLParser parser parse: (ReadStream on: m).
			document writeOn: aWriter ]! !

BPSpyMaker subclass: #BPSpyMakerAbstractSimpleActivity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Instrumentation'!

!BPSpyMakerAbstractSimpleActivity commentStamp: '<historical>' prior: 0!
A BPSpyMakerAbstractSimpleActivity is xxxxxxxxx.
!

!BPSpyMakerAbstractSimpleActivity methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 23:52'!
event
	^ ''! !

!BPSpyMakerAbstractSimpleActivity methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 23:51'!
instrumentationMsg: aModel
	^ '<activitiy>' 
	,'<processName>',aModel myProcess aName,'</processName>'
	,'<xPath>',aModel myDocument xpath,'</xPath>'
	,'<event>', self event,'</event>'
	,'</activitiy>'! !

BPSpyMakerAbstractSimpleActivity subclass: #BPSpyMakerSimpleAfter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Instrumentation'!

!BPSpyMakerSimpleAfter commentStamp: '<historical>' prior: 0!
A BPSpyMakerSimpleAfter is xxxxxxxxx.
!

!BPSpyMakerSimpleAfter methodsFor: 'build' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 22:41'!
buildXml: aModel
	|name gt|
	name:=aModel aName.
	gt:= BPInstrumentationType newGenericType: aModel.
	lstMakers add:
	gt tizq , 'assign name="a4bpAfter',name,'" ',gt ns,'>
	',gt tizq,'copy>
		',gt tizq,'from expressionLanguage="urn:oasis:names:tc:wsbpel:2.0:sublang:xpath1.0">
                    <!![CDATA["',(self instrumentationMsg: aModel),'"]]>
      </',gt pf,'from>
		',gt tizq,'to part="parameters" variable="a4bpInInstrumentation">
                    ',gt tizq,'query queryLanguage="urn:oasis:names:tc:wsbpel:2.0:sublang:xpath1.0">
                        <!![CDATA[a4bp:request]]>
                    </',gt pf,'query>
       </',gt pf,'to>
   </',gt pf,'copy>',
	'</',gt pf,'assign>'.


	lstMakers add:
	gt tizq , 'invoke name="a4bpAfterInvoke',name,'" 
                partnerLink="a4bpIntegration" portType="a4bp:A4bpInstrServicePortType"
                operation="instrumentation" inputVariable="a4bpInInstrumentation"
                outputVariable="a4bpOutInstrumentation" ',gt ns,'/>'.! !

!BPSpyMakerSimpleAfter methodsFor: 'build' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 23:52'!
event
	^ 'After'! !

BPSpyMakerAbstractSimpleActivity subclass: #BPSpyMakerSimpleBefore
	instanceVariableNames: 'aStringXML'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Instrumentation'!

!BPSpyMakerSimpleBefore commentStamp: '<historical>' prior: 0!
A BPSpyMakerSimpleBefore is xxxxxxxxx.

Instance Variables
	aStringXML:		<Object>

aStringXML
	- xxxxx
!

!BPSpyMakerSimpleBefore methodsFor: 'build' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 22:42'!
buildXml: aModel
	|name gt|
	name:=aModel aName.
	gt:= BPInstrumentationType newGenericType: aModel.

	lstMakers add:
	gt tizq , 'assign name="a4bpBefore',name,'" ',gt ns,'>
	',gt tizq,'copy>
		',gt tizq,'from expressionLanguage="urn:oasis:names:tc:wsbpel:2.0:sublang:xpath1.0">
                    <!![CDATA["',(self instrumentationMsg: aModel),'"]]>
      </',gt pf,'from>
		',gt tizq,'to part="parameters" variable="a4bpInInstrumentation">
                    ',gt tizq,'query queryLanguage="urn:oasis:names:tc:wsbpel:2.0:sublang:xpath1.0">
                        <!![CDATA[a4bp:request]]>
                    </',gt pf,'query>
       </',gt pf,'to>
   </',gt pf,'copy>',
	'</',gt pf,'assign>'.

	lstMakers add:
	gt tizq , 'invoke name="a4bpAfterInvoke',name,'" 
                partnerLink="a4bpIntegration" portType="a4bp:A4bpInstrServicePortType"
                operation="instrumentation" inputVariable="a4bpInInstrumentation"
                outputVariable="a4bpOutInstrumentation" ',gt ns,'/>'.! !

!BPSpyMakerSimpleBefore methodsFor: 'build' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 23:52'!
event
	^ 'Before'! !

BPSpyMaker subclass: #BPSpyMakerImport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Instrumentation'!

!BPSpyMakerImport commentStamp: '<historical>' prior: 0!
A BPSpyMakerPartnerLink is xxxxxxxxx.
!

!BPSpyMakerImport methodsFor: 'build' stamp: 'AlvaroJosePeraltaOcampo 8/1/2014 17:21'!
buildXml: aModel
	| name gt |
	name := aModel aName.
	gt := BPInstrumentationType newGenericType: aModel.
	lstMakers
		add:
		gt tizq , 'import location="a4bpInstrumentation.wsdl"
		namespace="http://a4bp.com/instrumentationService" importType="http://schemas.xmlsoap.org/wsdl/" ', gt ns , ' />'.! !

BPSpyMaker subclass: #BPSpyMakerPartnerLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Instrumentation'!

!BPSpyMakerPartnerLink commentStamp: '<historical>' prior: 0!
A BPSpyMakerPartnerLink is xxxxxxxxx.
!

!BPSpyMakerPartnerLink methodsFor: 'build' stamp: 'AlvaroJosePeraltaOcampo 7/31/2014 09:48'!
buildXml: aModel
	| name gt |
	name := aModel aName.
	gt := BPInstrumentationType newGenericType: aModel.
	lstMakers
		add:
		gt tizq , 'partnerLink name="a4bpIntegration" partnerLinkType="a4bp:A4bpInstrServicePortType"
			partnerRole="A4bpInstrServicePartnerRole" initializePartnerRole="no" ', gt ns , ' />'.! !

BPSpyMaker subclass: #BPSpyMakerSimpleInitVariables
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Instrumentation'!

!BPSpyMakerSimpleInitVariables commentStamp: '<historical>' prior: 0!
A BPSpyMakerSimpleAfter is xxxxxxxxx.
!

!BPSpyMakerSimpleInitVariables methodsFor: 'build' stamp: 'AlvaroJosePeraltaOcampo 8/2/2014 13:16'!
buildXml: aModel
	|name gt|
	name:=aModel aName.
	gt:= BPInstrumentationType newGenericType: aModel.
	"Example"	
	'
	<assign validate="no" name="InitializeA4BPVariables">
			<copy>
				<from>
					<literal>
						<ns:a4bpRes xmlns:ns="http://a4bp.com/instrumentationService"
							xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
							<ns:return>ns:return</ns:return>
						</ns:a4bpRes>
					</literal>
				</from>
				<to variable="a4bpOutInstrumentation" part="parameters"></to>
			</copy>
			<copy>
				<from>
					<literal>
						<ns:a4bpReq xmlns:ns="http://a4bp.com/instrumentationService"
							xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
							<ns:request>ns:request</ns:request>
						</ns:a4bpReq>
					</literal>
				</from>
				<to variable="a4bpInInstrumentation" part="parameters"></to>
			</copy>
		</assign>
	'.
	
	lstMakers add:
		gt tizq , 'assign validate="no" name="InitializeA4BPVariables" ',gt ns,'>
			
			',gt tizq ,'copy>
				',gt tizq ,'from>
					',gt tizq ,'literal>
						<ns:a4bpRes xmlns:ns="http://a4bp.com/instrumentationService"
							xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
							<ns:return>ns:return</ns:return>
						</ns:a4bpRes>
					</',gt pf,'literal>
				</',gt pf,'from>
				',gt tizq ,'to variable="a4bpOutInstrumentation" part="parameters"></',gt pf,'to>
			</',gt pf,'copy>
			
			',gt tizq ,'copy>
				',gt tizq ,'from>
					',gt tizq ,'literal>
						<ns:a4bpReq xmlns:ns="http://a4bp.com/instrumentationService"
							xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
							<ns:request>ns:request</ns:request>
						</ns:a4bpReq>
					</',gt pf,'literal>
				</',gt pf,'from>
				',gt tizq ,'to variable="a4bpInInstrumentation" part="parameters"></',gt pf,'to>
			</',gt pf,'copy>
		</',gt pf,'assign>
	'.
! !

BPSpyMaker subclass: #BPSpyMakerVariables
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Instrumentation'!

!BPSpyMakerVariables commentStamp: '<historical>' prior: 0!
A BPSpyMakerVariables is xxxxxxxxx.
!

!BPSpyMakerVariables methodsFor: 'build' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 22:43'!
buildXml: aModel
	|name gt|
	name:=aModel aName.
	gt:= BPInstrumentationType newGenericType: aModel.
	lstMakers add:
	gt tizq,'variable name="a4bpInInstrumentation" messageType="a4bp:a4bpRequest" ',gt ns,' />'.
	lstMakers add:
	gt tizq,'variable name="a4bpOutInstrumentation" messageType="a4bp:a4bpResponse" ',gt ns,'/>'! !

Object subclass: #BPSpyVCBPObject
	instanceVariableNames: 'bpObj'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Visualization'!

!BPSpyVCBPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:36'!
bpObj: abpObj
	bpObj := abpObj! !

!BPSpyVCBPObject methodsFor: 'private' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 05:50'!
executeInRoassal2: glmc
	|r2|
	r2:=glmc roassal2.
	r2
		painting: [ :view :viewBuilder | self executeVisualization: view ];
		title: BPUII18n msg msgVisualization.! !

!BPSpyVCBPObject methodsFor: 'private' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:36'!
executeInRoassal3d: glmc
	glmc roassal3d
		painting: [ :view :viewBuilder | self executeVisualization: view ];
		title: BPUII18n msg msgVisualization! !

!BPSpyVCBPObject methodsFor: 'private' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:36'!
executeInRoassal: glmc
	glmc roassal
		painting: [ :view :viewBuilder | self executeVisualization: view ];
		title: BPUII18n msg msgVisualization! !

!BPSpyVCBPObject methodsFor: 'execute' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:36'!
executeVisualization: view
	| v p |
	v := view.
	p := bpObj.
	v shape label.
	v node: [ p ]! !

!BPSpyVCBPObject methodsFor: 'execute' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:36'!
executeVisualizationOnGLMC: glmc
	self executeInRoassal: glmc! !

!BPSpyVCBPObject methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:36'!
initialize
	super initialize.! !

BPSpyVCBPObject subclass: #BPSpyVCBasic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Visualization'!

!BPSpyVCBasic methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 09:00'!
executeVisualization: view
	| b |
	"
	view is a Roasal2 engine
	"
	b := RTMondrianViewBuilder new.
	view @ RTDraggableView.
	b view: view.
	" 
	Base on spy core objects 
	BPSpyProfile -> * BPSpyProcess -> * BPSpyActivity
	"
	b nodes:  bpObj process forEach:[ :n|
		b shape rectangle size: [:a| a count * 10]; borderColor: Color black.
		b interaction popupText: [ :a | a aName ] . 
		b nodes: n activities
	].
	b build.! !

BPSpyVCBPObject subclass: #BPSpyVCVisualizeOn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Visualization'!

!BPSpyVCVisualizeOn methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:59'!
executeVisualization: view
	bpObj visualizeOn: view.! !

Object subclass: #BPSpyVCBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Visualization'!

!BPSpyVCBuilder methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:49'!
visitBPSpyInstanceController: aModel
	| visualizations |
	visualizations := OrderedCollection new.
	^ visualizations! !

!BPSpyVCBuilder methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:51'!
visitBPUINodeProfiler: aModel
	| visualizations bpvc |
	visualizations := OrderedCollection new.
	"1"
	bpvc := BPSpyVCBasic new.
	bpvc bpObj: aModel profiler.
	visualizations add: bpvc.
	"2"
	bpvc := BPSpyVCVisualizeOn new.
	bpvc bpObj: aModel profiler.
	visualizations add: bpvc.
	
	^ visualizations! !

!BPSpyVCBuilder methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:47'!
visitBPUINodeToProfile: aModel
	| visualizations |
	visualizations := OrderedCollection new.
	^ visualizations! !

Object subclass: #BPUIGLMActionSpyMainTreeBuilderVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-View-Action'!

!BPUIGLMActionSpyMainTreeBuilderVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 4/21/2015 12:14'!
basicActions: aModel
	|actions act|
	actions:= OrderedCollection new.

	"Inspect Element"
	act:=GLMGenericAction new 
	action:[aModel inspect];
	"category:'Inspect';"
	title:A4BPUII18n msg msgInspect.
	actions add:act.
	^ actions.! !

!BPUIGLMActionSpyMainTreeBuilderVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:49'!
visitBPSpyInstanceController: aModel
	|actions act|
	actions:= self basicActions:aModel.

	"Create Counting profile"
	"
	act:=GLMGenericAction new 
	action:[ ];
	category:'Spy';
	title: 'Counting profile'.
	actions add:act.
	"
	^ actions.! !

!BPUIGLMActionSpyMainTreeBuilderVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:29'!
visitBPUINodeProfiler: aModel
	|actions act|
	actions:= self basicActions:aModel.

	"Roassal2 Easel"
	act:=GLMGenericAction new 
	action:[ BPGLMRoassal2Easel openOn:{#node->(aModel profiler)}];
	category: A4BPUII18n msg msgBrowser;
	title: A4BPUII18n msg msgInRoassal2Easel.
	actions add:act.

	"Start"
	act:=GLMGenericAction new 
	action:[ BPSpyListener instance addObserver: aModel profiler ];
	category:'Listener';
	title: 'Start'.
	actions add:act.
	
	"Stop"
	act:=GLMGenericAction new 
	action:[ BPSpyListener instance removeObserver: aModel profiler];
	category:'Listener';
	title: 'Stop'.
	actions add:act.
	
	^ actions.! !

!BPUIGLMActionSpyMainTreeBuilderVisitor methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 07:01'!
visitBPUINodeToProfile: aModel
	|actions act|
	actions:= self basicActions:aModel.

	"Create Counting profile"
	act:=GLMGenericAction new 
	action:[:glm| 
		|profiler|
		profiler:=BPSpyProfileCounting startProfilerIn: aModel bpModel.
		aModel addProfiler:profiler.
		glm update. ];
	category:'Spy';
	title: 'Counting profile'.
	actions add:act.
	
	"Create Counting profile"
	act:=GLMGenericAction new 
	action:[:glm| 
		|profiler|
		profiler:=BPSpyProfileHapao2 startProfilerIn: aModel bpModel.
		aModel addProfiler:profiler.
		glm update. ];
	category:'Spy';
	title: 'Hapao2 profile'.
	actions add:act.
	
	

	^ actions.! !

Object subclass: #BPUINodeSpy
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-View-Model'!

BPUINodeSpy subclass: #BPUINodeProfiler
	instanceVariableNames: 'profiler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-View-Model'!

!BPUINodeProfiler class methodsFor: 'build' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:21'!
build: aProfiler
	| nodeProfiler |
	nodeProfiler := self new.
	nodeProfiler profiler: aProfiler.
	^ nodeProfiler! !

!BPUINodeProfiler methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:48'!
aName
	^ profiler aName! !

!BPUINodeProfiler methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 17:51'!
accept: aVisitor
	^ aVisitor visitBPUINodeProfiler: self! !

!BPUINodeProfiler methodsFor: 'delete' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:38'!
delete
	profiler delete.
	parent deleteNode:self! !

!BPUINodeProfiler methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 15:18'!
getChildrenNodes
	^ OrderedCollection new.! !

!BPUINodeProfiler methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:20'!
label
	^ profiler label! !

!BPUINodeProfiler methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:14'!
profiler
	^ profiler! !

!BPUINodeProfiler methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:14'!
profiler: aProfiler
	^ profiler := aProfiler ! !

!BPUINodeSpy methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:39'!
deleteNode: aNode! !

!BPUINodeSpy methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:37'!
parent
	^ parent! !

!BPUINodeSpy methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:38'!
parent: aParent
	^ parent := aParent! !

BPUINodeSpy subclass: #BPUINodeToProfile
	instanceVariableNames: 'bpModel lstNodeProfile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-View-Model'!

!BPUINodeToProfile class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 15:03'!
build: aModel
	| node |
	node := self new.
	node bpModel: aModel.
	^ node! !

!BPUINodeToProfile methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 15:15'!
aName
	^ bpModel aName.! !

!BPUINodeToProfile methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 17:52'!
accept: aVisitor
	^ aVisitor visitBPUINodeToProfile: self! !

!BPUINodeToProfile methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:39'!
addNodeProfiler: aNodeProfiler
	lstNodeProfile at: aNodeProfiler aName put: aNodeProfiler! !

!BPUINodeToProfile methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:13'!
addProfiler: aProfiler
	| nodeProfiler |
	nodeProfiler := BPUINodeProfiler build: aProfiler.
	self addNodeProfiler: nodeProfiler! !

!BPUINodeToProfile methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 15:00'!
bpModel
	^ bpModel! !

!BPUINodeToProfile methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 15:00'!
bpModel: aBPModel
	bpModel := aBPModel! !

!BPUINodeToProfile methodsFor: 'actions' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:40'!
deleteNode: aNode
	lstNodeProfile removeKey: aNode aName.! !

!BPUINodeToProfile methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:18'!
getChildrenNodes
	^ self lstNodeProfile! !

!BPUINodeToProfile methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 4/22/2015 08:53'!
initialize
	super initialize.
	lstNodeProfile := Dictionary new.
	bpModel := A4BPEmptyObj instance.! !

!BPUINodeToProfile methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 15:10'!
label
	^ bpModel label.! !

!BPUINodeToProfile methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 14:58'!
lstNodeProfile
	^ lstNodeProfile ! !

Object subclass: #BPWSSOAInstrumentation
	instanceVariableNames: 'commadDictionary ip port context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-SOA-Integration'!

!BPWSSOAInstrumentation commentStamp: '<historical>' prior: 0!
A BPWSSOAInstrumentation is xxxxxxxxx.

Instance Variables
	commadDictionary:		<Object>
	context:		<Object>
	ip:		<Object>
	port:		<Object>

commadDictionary
	- xxxxx

context
	- xxxxx

ip
	- xxxxx

port
	- xxxxx
!

!BPWSSOAInstrumentation class methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 01:24'!
start
	"self start"
	|newServer|
	newServer := self new.
   ZnServer startDefaultOn: 8089.
	ZnServer default delegate 
	map: newServer context to:newServer;
	map: 'redirect-to-a4bp' to: [ :request | ZnResponse redirect: newServer context ];
	map: '/' to: 'redirect-to-a4bp'.
	ZnServer default start.! !

!BPWSSOAInstrumentation class methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 01:10'!
stop
	ZnServer default start. ! !

!BPWSSOAInstrumentation methodsFor: 'endpoint' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 02:11'!
baseEndPoint
	^ 'http://' , ip , ':' , port! !

!BPWSSOAInstrumentation methodsFor: 'endpoint' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 02:15'!
baseQuestionWsdl
	^ '?wsdl'! !

!BPWSSOAInstrumentation methodsFor: 'endpoint' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 02:09'!
basicPath
	^ '/' , context! !

!BPWSSOAInstrumentation methodsFor: 'resp' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 01:34'!
basicResp
^
'<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:ins="http://a4bp.com/instrumentationService">
   <soapenv:Header/>
   <soapenv:Body>
      <ins:a4bpRes>
         <ins:return>ok</ins:return>
      </ins:a4bpRes>
   </soapenv:Body>
</soapenv:Envelope>'! !

!BPWSSOAInstrumentation methodsFor: 'public' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 01:59'!
context
	^ context! !

!BPWSSOAInstrumentation methodsFor: 'endpoint' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 02:11'!
endpointHttp
	^ self baseEndPoint, self pathHttp.! !

!BPWSSOAInstrumentation methodsFor: 'endpoint' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 02:12'!
endpointSoap11
	^ self baseEndPoint, self pathSoap11.
	! !

!BPWSSOAInstrumentation methodsFor: 'endpoint' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 02:13'!
endpointSoap12
	^ self baseEndPoint , self pathSoap12! !

!BPWSSOAInstrumentation methodsFor: 'public' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 22:08'!
handleRequest: request
	| uri resp |
	uri := request uri asString.
	BPLog d: 'INIT handleRequest: request'.
	resp := self prepareWSResp: uri.
	resp ifNil:[
			BPLog d: 'self notifyToAllListener: request entity'.
			self notifyToAllListener: request entity.
			BPLog d: 'resp := self basicResp '.
			resp := self basicResp 
	].
	BPLog d: 'END handleRequest: request'.
	^ ZnResponse ok: (ZnEntity text: resp)! !

!BPWSSOAInstrumentation methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 22:00'!
initialize
	super initialize.
	commadDictionary := Dictionary new.
	ip := 'localhost'.
	port := '8089'.
	context := 'a4bp'.
	"
	commadDictionary at: self pathHttp put: self basicResp.
	commadDictionary at: self pathSoap11 put: self basicResp.
	commadDictionary at: self pathSoap12 put: self basicResp.
	"
	commadDictionary at: self pathHttpWsdl put: self wsdl.
	commadDictionary at: self pathSoap11Wsdl put: self wsdl.
	commadDictionary at: self pathSoap12Wsdl put: self wsdl.! !

!BPWSSOAInstrumentation methodsFor: 'xsd' stamp: 'AlvaroJosePeraltaOcampo 7/17/2014 01:25'!
instrumentationXSD
	^ '<?xml version="1.0" encoding="UTF-8" ?>
<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema"
            xmlns:a4bp="http://www.a4bp.com"
            targetNamespace="http://www.a4bp.com"
            elementFormDefault="qualified">
  <xsd:element name="bpObject">
    <xsd:annotation>
      <xsd:documentation>
        This is a sample xsd to create a instrumentation message in bpelComplexityAnalyzer
      </xsd:documentation>
    </xsd:annotation>
    <xsd:complexType>
      <xsd:sequence>
        <xsd:element name="id" type="xsd:string" maxOccurs="1"/>
        <xsd:element name="activity" type="a4bp:bpActivity" minOccurs="0"
                     maxOccurs="1"/>
      </xsd:sequence>
    </xsd:complexType>
  </xsd:element>
  <xsd:complexType name="bpActivity">
    <xsd:sequence>
      <xsd:element name="id" type="xsd:string" maxOccurs="1"/>
      <xsd:element name="name" type="xsd:string" maxOccurs="1"/>
    </xsd:sequence>
  </xsd:complexType>
</xsd:schema>
'! !

!BPWSSOAInstrumentation methodsFor: 'public' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 01:57'!
ip
^ ip! !

!BPWSSOAInstrumentation methodsFor: 'notify-listener' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 22:31'!
notifyToAllListener: entity
	BPLog d: 'INIT BPSpyListener instance notifyToAllListener:entity string'.
	BPSpyListener instance notifyToAllListener:entity string.
	BPLog d: 'END BPSpyListener instance notifyToAllListener:entity string'.! !

!BPWSSOAInstrumentation methodsFor: 'endpoint' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 02:23'!
pathBaseWsdl
	^ self pathHttp,self baseQuestionWsdl ! !

!BPWSSOAInstrumentation methodsFor: 'endpoint' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 02:19'!
pathHttp
	^ self basicPath , '/A4bpInstrServiceHttpEndpoint'! !

!BPWSSOAInstrumentation methodsFor: 'endpoint' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 02:15'!
pathHttpWsdl
	^ self pathHttp,self baseQuestionWsdl ! !

!BPWSSOAInstrumentation methodsFor: 'endpoint' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 02:12'!
pathSoap11
	^ self basicPath , '/A4bpInstrServiceHttpSoap11Endpoint'! !

!BPWSSOAInstrumentation methodsFor: 'endpoint' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 02:15'!
pathSoap11Wsdl
	^ self pathSoap11 , self baseQuestionWsdl ! !

!BPWSSOAInstrumentation methodsFor: 'endpoint' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 02:12'!
pathSoap12
	^ self basicPath , '/A4bpInstrServiceHttpSoap12Endpoint'! !

!BPWSSOAInstrumentation methodsFor: 'endpoint' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 02:15'!
pathSoap12Wsdl
	^ self pathSoap12 , self baseQuestionWsdl ! !

!BPWSSOAInstrumentation methodsFor: 'endpoint' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 02:26'!
pathWsdl
	^ self basicPath ,self baseQuestionWsdl ! !

!BPWSSOAInstrumentation methodsFor: 'public' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 01:57'!
port
 ^ port! !

!BPWSSOAInstrumentation methodsFor: 'resp' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 22:08'!
prepareWSResp: uri
	| resp |
	resp := nil.
	[ resp := commadDictionary at: uri ]
		on: KeyNotFound
		do: [  ].
	^ resp! !

!BPWSSOAInstrumentation methodsFor: 'public' stamp: 'AlvaroJosePeraltaOcampo 7/30/2014 00:54'!
value: request
  ^ self handleRequest: request! !

!BPWSSOAInstrumentation methodsFor: 'wsdl' stamp: 'AlvaroJosePeraltaOcampo 8/1/2014 17:19'!
wsdl
^
'<?xml version="1.0" encoding="UTF-8"?>
<wsdl:definitions targetNamespace="http://a4bp.com/instrumentationService"
                  xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/"
                  xmlns:a4bp="http://a4bp.com/instrumentationService"
                  xmlns:mime="http://schemas.xmlsoap.org/wsdl/mime/"
                  xmlns:soap12="http://schemas.xmlsoap.org/wsdl/soap12/"
                  xmlns:http="http://schemas.xmlsoap.org/wsdl/http/"
                  xmlns:ns1="http://org.apache.a4bp/xsd"
                  xmlns:wsaw="http://www.w3.org/2006/05/addressing/wsdl"
                  xmlns:ns="http://a4bp.com/instrumentationService"
                  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
                  xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
                  xmlns:plnk="http://docs.oasis-open.org/wsbpel/2.0/plnktype" >
    <wsdl:documentation>a4bpInstrumentation</wsdl:documentation>
    <wsdl:types>
        <xsd:schema targetNamespace="http://a4bp.com/instrumentationService"
                    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
                    attributeFormDefault="qualified"
                    elementFormDefault="qualified">
            <xsd:element name="a4bpReq">
                <xsd:complexType>
                    <xsd:sequence>
                        <xsd:element minOccurs="1" name="request"
                                     nillable="true" type="xsd:string"/>
                    </xsd:sequence>
                </xsd:complexType>
            </xsd:element>
            <xsd:element name="a4bpRes">
                <xsd:complexType>
                    <xsd:sequence>
                        <xsd:element minOccurs="1" name="return" nillable="true"
                                     type="xsd:string"/>
                    </xsd:sequence>
                </xsd:complexType>
            </xsd:element>
        </xsd:schema>
    </wsdl:types>
    <wsdl:message name="a4bpRequest">
        <wsdl:part name="parameters" element="a4bp:a4bpReq"/>
    </wsdl:message>
    <wsdl:message name="a4bpResponse">
        <wsdl:part name="parameters" element="a4bp:a4bpRes"/>
    </wsdl:message>
    <wsdl:portType name="A4bpInstrServicePortType">
        <wsdl:operation name="instrumentation">
            <wsdl:input message="a4bp:a4bpRequest"
                        wsaw:Action="urn:a4bpRequest"/>
            <wsdl:output message="a4bp:a4bpResponse"
                         wsaw:Action="urn:a4bpResponse"/>
        </wsdl:operation>
    </wsdl:portType>
    <wsdl:binding name="A4bpInstrServiceSoap11Binding"
                  type="a4bp:A4bpInstrServicePortType">
        <soap:binding transport="http://schemas.xmlsoap.org/soap/http"
                      style="document"/>
        <wsdl:operation name="instrumentation">
            <soap:operation soapAction="urn:instrumentation" style="document"/>
            <wsdl:input>
                <soap:body use="literal"/>
            </wsdl:input>
            <wsdl:output>
                <soap:body use="literal"/>
            </wsdl:output>
        </wsdl:operation>
    </wsdl:binding>
    <wsdl:binding name="A4bpInstrServiceSoap12Binding"
                  type="a4bp:A4bpInstrServicePortType">
        <soap12:binding transport="http://schemas.xmlsoap.org/soap/http"
                        style="document"/>
        <wsdl:operation name="instrumentation">
            <soap12:operation soapAction="urn:instrumentation"
                              style="document"/>
            <wsdl:input>
                <soap12:body use="literal"/>
            </wsdl:input>
            <wsdl:output>
                <soap12:body use="literal"/>
            </wsdl:output>
        </wsdl:operation>
    </wsdl:binding>
    <wsdl:binding name="A4bpInstrServiceHttpBinding"
                  type="a4bp:A4bpInstrServicePortType">
        <http:binding verb="POST"/>
        <wsdl:operation name="instrumentation">
            <http:operation location="A4bpInstrService/instrumentation"/>
            <wsdl:input>
                <mime:content type="text/xml" part="instrumentation"/>
            </wsdl:input>
            <wsdl:output>
                <mime:content type="text/xml" part="instrumentation"/>
            </wsdl:output>
        </wsdl:operation>
    </wsdl:binding>
    <wsdl:service name="A4bpInstrService">
        <wsdl:port name="A4bpInstrServiceHttpSoap11Endpoint"
                   binding="a4bp:A4bpInstrServiceSoap11Binding">
            <soap:address location="',self endpointSoap11,'"/>
        </wsdl:port>
        <wsdl:port name="A4bpInstrServiceHttpSoap12Endpoint"
                   binding="a4bp:A4bpInstrServiceSoap12Binding">
            <soap12:address location="',self endpointSoap12,'"/>
        </wsdl:port>
        <wsdl:port name="A4bpInstrServiceHttpEndpoint"
                   binding="a4bp:A4bpInstrServiceHttpBinding">
            <http:address location="',self endpointHttp,'"/>
        </wsdl:port>
    </wsdl:service>

	<plnk:partnerLinkType name="A4bpInstrServicePortType">
		<plnk:role name="A4bpInstrServicePartnerRole" portType="a4bp:A4bpInstrServicePortType" />
	</plnk:partnerLinkType>
</wsdl:definitions>'! !

!BPWSSOAInstrumentation methodsFor: 'wsdl' stamp: 'AlvaroJosePeraltaOcampo 8/1/2014 16:02'!
wsdlName
	^ 'a4bpInstrumentation.wsdl'! !

Object subclass: #S2pyCopy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Core'!

S2pyCopy class
	instanceVariableNames: 'currentTestCase currentTestMethod currentTestMethodSpy'!

S2pyCopy class
	instanceVariableNames: 'currentTestCase currentTestMethod currentTestMethodSpy'!

S2pyCopy subclass: #BPSpyMeta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Core'!

BPSpyMeta subclass: #BPSpyActivity
	instanceVariableNames: 'bpActivity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Core'!

!BPSpyActivity class methodsFor: 'build' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 04:34'!
buildSpyActivity: aBPActivity
	| spyActivity |
	spyActivity := self new.
	spyActivity bpActivity: aBPActivity.
	^ spyActivity! !

!BPSpyActivity methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 04:35'!
aName
	^ bpActivity xpath! !

!BPSpyActivity methodsFor: 'hooks' stamp: 'AlvaroJosePeraltaOcampo 7/26/2014 22:35'!
afterExecution: aName with: aVariable in: process ! !

!BPSpyActivity methodsFor: 'hooks' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 05:19'!
baseAfterExecution: aName with: aVariable in: process
	self afterExecution: aName with: aVariable in: process.! !

!BPSpyActivity methodsFor: 'hooks' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 05:20'!
baseBeforeExecution: aName with: aVariable in: process
	self beforeExecution: aName with: aVariable in: process.! !

!BPSpyActivity methodsFor: 'hooks' stamp: 'AlvaroJosePeraltaOcampo 7/26/2014 22:35'!
beforeExecution: aName with: aVariable in: process ! !

!BPSpyActivity methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 04:33'!
bpActivity
	^ bpActivity! !

!BPSpyActivity methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 04:33'!
bpActivity: aBPActivity
	^ bpActivity := aBPActivity! !

BPSpyActivity subclass: #BPSpyActivityCounting
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Core-Counting'!

!BPSpyActivityCounting methodsFor: 'hooks' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 05:22'!
beforeExecution: aName with: aVariable in: process
	count := count + 1! !

!BPSpyActivityCounting methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 05:36'!
count
 ^ count ! !

!BPSpyActivityCounting methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 7/26/2014 22:53'!
initialize
	super initialize.
	count := 0! !

BPSpyActivity subclass: #BPSpyActivityHapao2
	instanceVariableNames: 'count hasBeenExecuted calls callers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Core-Hapao2'!

BPSpyActivityHapao2 class
	instanceVariableNames: 'maxCalls maxLines maxCallers'!

BPSpyActivityHapao2 class
	instanceVariableNames: 'maxCalls maxLines maxCallers'!

!BPSpyActivityHapao2 class methodsFor: 'accesing' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 07:11'!
maxCallers
	maxCallers ifNil: [ maxCallers := 0 ].
	^ maxCallers! !

!BPSpyActivityHapao2 class methodsFor: 'accesing' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 07:11'!
maxCallers: anObject
	maxCallers := anObject! !

!BPSpyActivityHapao2 class methodsFor: 'accesing' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 07:11'!
maxCalls
	maxCalls ifNil: [ maxCalls := 0 ].
	^ maxCalls! !

!BPSpyActivityHapao2 class methodsFor: 'accesing' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 07:11'!
maxCalls: anObject
	maxCalls := anObject! !

!BPSpyActivityHapao2 class methodsFor: 'accesing' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 07:11'!
maxLines
	maxLines ifNil: [ maxLines := 0 ].
	^ maxLines! !

!BPSpyActivityHapao2 class methodsFor: 'accesing' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 07:11'!
maxLines: anObject
	maxLines := anObject! !

!BPSpyActivityHapao2 methodsFor: 'hooks' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 07:00'!
beforeExecution: aName with: aVariable in: process
	count := count + 1! !

!BPSpyActivityHapao2 methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 07:17'!
callers
	^ callers! !

!BPSpyActivityHapao2 methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:49'!
calls
	^ calls! !

!BPSpyActivityHapao2 methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 07:00'!
count
 ^ count ! !

!BPSpyActivityHapao2 methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 07:21'!
initialize
	super initialize.
	count := 0.
	hasBeenExecuted := false.
	calls := 0.
	callers := Set new.! !

!BPSpyActivityHapao2 methodsFor: 'accesing' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 09:02'!
selfCallers
	^ OrderedCollection new! !

!BPSpyActivityHapao2 methodsFor: 'accesing' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 09:02'!
spyCallees
	^ OrderedCollection new! !

!BPSpyActivityHapao2 methodsFor: 'accesing' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 09:02'!
spyCallers
	^ OrderedCollection new! !

BPSpyActivity subclass: #BPSpyActivityPerformance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Core-Performance'!

!BPSpyActivityPerformance methodsFor: 'hooks' stamp: 'AlvaroJosePeraltaOcampo 7/26/2014 22:48'!
afterExecution: aName with: aVariable in: process ! !

!BPSpyActivityPerformance methodsFor: 'hooks' stamp: 'AlvaroJosePeraltaOcampo 7/26/2014 22:49'!
beforeExecution: aName with: aVariable in: process! !

BPSpyMeta subclass: #BPSpyProcess
	instanceVariableNames: 'activities bpProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Core'!

!BPSpyProcess class methodsFor: 'build' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 04:42'!
buildSpyProcess: aBPProcess
	| spyProcess |
	spyProcess := self new.
	spyProcess bpProcess: aBPProcess.
	^ spyProcess! !

!BPSpyProcess methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 04:32'!
aName
	^ bpProcess aName! !

!BPSpyProcess methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 05:32'!
activities
^ activities! !

!BPSpyProcess methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 04:47'!
addActivity: aBPActivity
	|spyActivity|
	spyActivity := BPSpyActivity buildSpyActivity: aBPActivity.
	activities at: spyActivity aName put:spyActivity.
	^ spyActivity ! !

!BPSpyProcess methodsFor: 'hooks' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 00:04'!
afterExecution: aName with: aVariable! !

!BPSpyProcess methodsFor: 'hooks' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 05:21'!
baseAfterExecution: aName with: aVariable
	self afterExecution: aName with: aVariable.
	[ 
	| act |

	act := activities at: aName.
	act baseAfterExecution: aName with: aVariable in:self.
	]
		on: KeyNotFound
		do: [ :er | BPLog d: ('ERROR (BPSpyProcess>>baseAfterExecution: aName with: aVariable) error(',er asString,')'). ]! !

!BPSpyProcess methodsFor: 'hooks' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 05:21'!
baseBeforeExecution: aName with: aVariable
	self beforeExecution: aName with: aVariable.
	[ 
	| act |
	act := activities at: aName.
	act baseBeforeExecution: aName with: aVariable in:self.
	]
		on: KeyNotFound
		do: [ :er | BPLog d: ('ERROR (BPSpyProcess>>baseBeforeExecution: aName with: aVariable) error(',er asString,')'). ]! !

!BPSpyProcess methodsFor: 'hooks' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 00:04'!
beforeExecution: aName with: aVariable! !

!BPSpyProcess methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 04:24'!
bpProcess
	^ bpProcess! !

!BPSpyProcess methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 04:47'!
bpProcess: aBPProcess
	bpProcess := aBPProcess.
	bpProcess allActivities do: [ :act | self addActivity: act ].
	^ bpProcess! !

!BPSpyProcess methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 7/26/2014 22:37'!
initialize
	super initialize.
	activities := Dictionary new.! !

BPSpyProcess subclass: #BPSpyProcessCounting
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Core-Counting'!

!BPSpyProcessCounting methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 04:47'!
addActivity: aBPActivity
	|spyActivity|
	spyActivity := BPSpyActivityCounting buildSpyActivity: aBPActivity.
	activities at: spyActivity aName put:spyActivity .
	^ spyActivity ! !

!BPSpyProcessCounting methodsFor: 'notifications' stamp: 'AlvaroJosePeraltaOcampo 7/26/2014 23:09'!
notifyAfterExecution: aModel
	"find the activity name"
	! !

BPSpyProcess subclass: #BPSpyProcessHapao2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Core-Hapao2'!

!BPSpyProcessHapao2 methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 07:18'!
addActivity: aBPActivity
	|spyActivity|
	spyActivity := BPSpyActivityHapao2 buildSpyActivity: aBPActivity.
	activities at: spyActivity aName put:spyActivity .
	^ spyActivity ! !

!BPSpyProcessHapao2 methodsFor: 'notifications' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 07:00'!
notifyAfterExecution: aModel
	"find the activity name"
	! !

BPSpyProcess subclass: #BPSpyProcessPerformance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Core-Performance'!

BPSpyMeta subclass: #BPSpyProfile
	instanceVariableNames: 'process lstObservables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Core'!

!BPSpyProfile class methodsFor: 'starting' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:11'!
startProfilerIn: aModel
	| profiler |
	profiler := self new.
	profiler addProcess: aModel.
	^ profiler.! !

!BPSpyProfile methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:49'!
aName
	^ self hash asString! !

!BPSpyProfile methodsFor: 'accesing-readOnly' stamp: 'AlvaroJosePeraltaOcampo 9/12/2014 07:47'!
activities
 ^ self allActivities ! !

!BPSpyProfile methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:42'!
addObservables: aObservable
	lstObservables add: aObservable! !

!BPSpyProfile methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 04:31'!
addProcess: aBPProcess
	|spyProcess|
	spyProcess := BPSpyProcess buildSpyProcess: aBPProcess.
	process at: spyProcess aName put: spyProcess! !

!BPSpyProfile methodsFor: 'accesing-readOnly' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 07:20'!
allActivities
	| lst |
	lst := OrderedCollection new.
	process do: [ :p | lst addAll: (p activities values) ].
	^ lst.! !

!BPSpyProfile methodsFor: 'delete' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:47'!
delete
	lstObservables do:[ :o | o removeObserver: self].! !

!BPSpyProfile methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:56'!
getActivityShapeBuilder
	| methodShapeBuilder |
	methodShapeBuilder := RTShapeBuilder new.
	methodShapeBuilder rectangle
		borderColor: Color black.
	^ methodShapeBuilder! !

!BPSpyProfile methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:55'!
getClassShapeBuilder
	| classShapeBuilder |
	classShapeBuilder := RTShapeBuilder new.
	classShapeBuilder rectangle
		borderColor: Color black.
	^ classShapeBuilder! !

!BPSpyProfile methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:52'!
getInteractionBuilder
	| interactionBuilder |
	interactionBuilder := RTInteractionBuilder new.
	interactionBuilder menu
		item: 'inspect' action: [ :el | el model inspect ];
		item: 'browse' action: [ :m | m model browse ].
	^ interactionBuilder! !

!BPSpyProfile methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:56'!
getMethodShapeBuilder
	| methodShapeBuilder |
	methodShapeBuilder := RTShapeBuilder new.
	methodShapeBuilder rectangle
		borderColor: Color black.
	^ methodShapeBuilder! !

!BPSpyProfile methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:56'!
getProcessShapeBuilder
	| classShapeBuilder |
	classShapeBuilder := RTShapeBuilder new.
	classShapeBuilder rectangle
		borderColor: Color black.
	^ classShapeBuilder! !

!BPSpyProfile methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:41'!
initialize
	super initialize.
	process := Dictionary new.
	lstObservables := OrderedCollection new! !

!BPSpyProfile methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:08'!
label
	^ 'BPSpyProfiler'! !

!BPSpyProfile methodsFor: 'notifications' stamp: 'AlvaroJosePeraltaOcampo 7/26/2014 23:03'!
notifyAfterExecution: aModel! !

!BPSpyProfile methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 05:32'!
process
	^ process! !

!BPSpyProfile methodsFor: 'update' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 05:16'!
updateSpy: entity
	| document |
	BPLog d:'INIT BPSpyProfiler>>updateSpy: entity'.
	document := XMLElement new.
	[
	|lst|

	BPLog d:'INIT document := BPParserXMLIntegration parseString: entity'.
	document := BPParserXMLIntegration parseString: entity.
	BPLog d:'END document := BPParserXMLIntegration parseString: entity'.
	lst := document allElementsNamed: 'request'.
	
	lst do:[ :doc | 
		|xmlContent processName xpath event spyBPProcess| 

		xmlContent:= doc contentString.
		'<activitiy>
			<processName>a4bpProcess008</processName>
			<xPath>/bpel:process/bpel:sequence/bpel:reply</xPath>
			<event>After</event>
		</activitiy>'.		
		document := BPParserXMLIntegration parseString: xmlContent.
		processName:= (document allElementsNamed: 'processName') first contentString.
		xpath:= (document allElementsNamed: 'xPath') first contentString.
		event:= (document allElementsNamed: 'event') first contentString.
		"find the processName"
		[
			spyBPProcess:= process at: processName.
			('After' = event) ifTrue:[ spyBPProcess baseAfterExecution: xpath with: '' ].
			('Before' = event) ifTrue:[ spyBPProcess baseBeforeExecution: xpath with: ''].
		]
		on:KeyNotFound 
		do:[]
		"end lst do:[ :doc | "
		].
	]	on: Error
		do: [ :er | BPLog d: ('ERROR (BPSpyProfiler>>updateSpy: entity) error(',er asString,')'). ]! !

BPSpyProfile subclass: #BPSpyProfileCounting
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Core-Counting'!

!BPSpyProfileCounting methodsFor: 'notifications' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 04:32'!
addProcess: aBPProcess
	|spyProcess|
	spyProcess := BPSpyProcessCounting buildSpyProcess: aBPProcess.
	process at: spyProcess aName put: spyProcess! !

!BPSpyProfileCounting methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/3/2014 18:09'!
label
	^ 'SpyProfileCounting'! !

!BPSpyProfileCounting methodsFor: 'notifications' stamp: 'AlvaroJosePeraltaOcampo 7/26/2014 23:11'!
notifyAfterExecution: aModel
	"process do: [ :p | p notifyAfterExecution: aModel ]"! !

!BPSpyProfileCounting methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:58'!
visualizeOn: view
	"This is a generated visualization"
	| allProcess  processShapeBuilder activityShapeBuilder  interactionBuilder classElements|
	interactionBuilder := self getInteractionBuilder.
	processShapeBuilder := self getProcessShapeBuilder.
	activityShapeBuilder := self getActivityShapeBuilder.
	classElements := RTGroup new. 
	allProcess := self process.
	allProcess do: [ :each | |mths classElement|
		classElement := (processShapeBuilder elementOn: each).
		view add: classElement.
		mths := (activityShapeBuilder elementsOn: each activities ).
		view addAll: mths.
		RTGridLayout on: mths.
		mths @ RTDraggable @ RTPopup.
		RTNest new on: classElement nest: mths.
		classElement @ RTDraggable.
		classElements add: classElement.
		interactionBuilder setUpElements: mths.			
	].
	interactionBuilder setUpElements: classElements.
	RTGridLayout on: classElements
	! !

BPSpyProfile subclass: #BPSpyProfileHapao2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Core-Hapao2'!

!BPSpyProfileHapao2 methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:58'!
addClassEdges: spyClasses scope: elements view: view
	RTEdge
		buildEdgesFromObjects: spyClasses
		from: [ :e | (spyClasses select: [ :i | i class = e class superclass ]) at: 1 ifAbsent: [ nil ] ]
		to: #yourself
		using: (RTLine new attachPoint: RTVerticalAttachPoint instance)
		inView: view
		scope: elements! !

!BPSpyProfileHapao2 methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:56'!
addMethodEdges: each scope: mths view: view
	| edges sb |
	sb := RTEdgeBuilder new
			view: view.
	sb shape shape: (RTLine new attachPoint: RTVerticalAttachPoint instance).
	"TODO verified the correct view
	edges := sb
					objects: each activities
					fromAll: #yourself 
					to: #yourself.

	edges do: #moveBehindItsExtremities
	"! !

!BPSpyProfileHapao2 methodsFor: 'notifications' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 07:18'!
addProcess: aBPProcess
	|spyProcess|
	spyProcess := BPSpyProcessHapao2 buildSpyProcess: aBPProcess.
	process at: spyProcess aName put: spyProcess! !

!BPSpyProfileHapao2 methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:57'!
hapaoPopupUsing: methodShapeBuilder
	^ RTPopup new
		group: [ :group :el | 
			| background intro label upper treeHolder treeBox callers callerElements callees calleeElements edges |
			upper := RTGroup new.
			intro := (RTLabel new
						color: Color black;
						text: 'Control flow of:') element.
			group add: intro.
			upper add: intro.
			label := (RTLabel new
						color: Color black;
						text: (#asString rtValue: el model)) element.
			group add: label.
			upper add: label.
			treeBox := (RTBox new
				color: Color transparent) element.
			group add: treeBox.			
			treeHolder := RTGroup new.
			treeHolder add: (methodShapeBuilder elementOn: el model).
			callers := el model spyCallers.
			callerElements := treeHolder addAll: (methodShapeBuilder elementsOn: callers).
			callees := el model spyCallees.
			calleeElements := treeHolder addAll: (methodShapeBuilder elementsOn: callees).
			edges := OrderedCollection new.
			callerElements do: [ :c | edges add: ((RTLine new color: Color white) edgeFrom: c to: treeHolder first)].
			calleeElements do: [ :c | edges add: ((RTLine new color: Color white) edgeFrom: treeHolder first to: c)].
			RTTreeLayout on: treeHolder edges: edges.
			group addAll: treeHolder.
			RTNest new centerOn: treeBox elements: treeHolder.
			upper add: treeBox.	
			RTVerticalLineLayout new alignCenter; on: upper.
			"this line should not be necessary :C"
			treeHolder do: [ :e | e translateBy: treeBox position ].
			background := (RTBox new
				color: Color lightGray;
				borderColor: Color black) element.
			RTNest new centerOn: background elements: group.
			group addAllFirst: edges.
			group addFirst: background ]! !

!BPSpyProfileHapao2 methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 07:04'!
label
	^ 'SpyHapao2'! !

!BPSpyProfileHapao2 methodsFor: 'notifications' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 07:00'!
notifyAfterExecution: aModel
	"process do: [ :p | p notifyAfterExecution: aModel ]"! !

!BPSpyProfileHapao2 methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 08:50'!
setMaxValues
	self allActivities
		do: [ :m | 
			BPSpyActivityHapao2 maxCallers: (BPSpyActivityHapao2 maxCallers max: m callers size).
			BPSpyActivityHapao2 maxCalls: (BPSpyActivityHapao2 maxCalls max: m calls).
			"
			m compiledMethod ifNotNil: [ BPSpyActivityHapao2 maxLines: (BPSpyActivityHapao2 maxLines max: m compiledMethod linesOfCode) ] 
			"
			]! !

!BPSpyProfileHapao2 methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 09:05'!
visualizeOn: view
	"This is a generated visualization"

	| allProcess processShapeBuilder activityShapeBuilder interactionBuilder classElements b |
	self setMaxValues.
	interactionBuilder := self getInteractionBuilder.
	processShapeBuilder := self getProcessShapeBuilder.
	activityShapeBuilder := self getActivityShapeBuilder.
	classElements := RTGroup new.
	allProcess := self process.
	allProcess
		do: [ :each | 
			| mths classElement |
			classElement := processShapeBuilder elementOn: each.
			view add: classElement.
			mths := activityShapeBuilder elementsOn: each activities.
			view addAll: mths.
			self addMethodEdges: each scope: mths view: view.
			RTTreeLayout on: mths.
			mths @ (self hapaoPopupUsing: activityShapeBuilder).
			RTNest new on: classElement nest: mths.
			classElement @ RTDraggable @ RTPopup @ RTLabelled.
			classElements add: classElement.
			interactionBuilder setUpElements: mths ].
	interactionBuilder setUpElements: classElements.
	self addClassEdges: allProcess scope: classElements view: view.
	RTTreeLayout on: classElements.
	
	"Show legend"
	b := RTLegend2Builder new.
	b view: view.
	b addText: 'Hapao show the coverage on which you have run it'.
	b addText: 'Big box = Process. Green Process are unit tests'.
	b addText: 'Inner box = method'.
	b addText: 'height = number of lines of code of '.
	b addText: 'width = number of methods that call it'.
	b addText: 'edge = static call between methods. Above calls below'.
	b addColor: Color black text: 'Activities well tested'.
	b addColor: Color gray text: 'Activities tested'.
	b addColor: Color red text: 'Activities not tested'.
	b build! !

BPSpyProfile subclass: #BPSpyProfilePerformance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Core-Performance'!

BPSpyProfile subclass: #BPSpyProfileTemporal
	instanceVariableNames: 'lstXML'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Spy-Core-Temporal'!

!BPSpyProfileTemporal commentStamp: 'AlvaroJosePeraltaOcampo 7/26/2014 23:12' prior: 0!
A BPSpyProfileTemporal is temporal implementation to test the conectivity.
!

!BPSpyProfileTemporal methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 7/26/2014 23:13'!
initialize
	super initialize.
	lstXML := OrderedCollection new.! !

!BPSpyProfileTemporal methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 7/26/2014 23:14'!
lstXML
	^ lstXML! !

!BPSpyProfileTemporal methodsFor: 'notifications' stamp: 'AlvaroJosePeraltaOcampo 7/26/2014 23:15'!
notifyAfterExecution: aModel
	lstXML add: aModel! !

!S2pyCopy class methodsFor: 'code generation' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:44'!
generate: profilerName
	"Public method to create a new profiler"
	
	^ self generate: profilerName category: profilerName asString! !

!S2pyCopy class methodsFor: 'util' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:44'!
generate: profilerName category: aCategory
	"
	
	Example of usage:
	self generate: 'S2C' category: 'S2py-Counting'
	"
	
	| profiler methodSpy classSpy packageSpy test |
	self assert: [ profilerName first isUppercase ].
	self assert: [ aCategory notEmpty ].
	
	profiler := S2Profiler subclass: profilerName asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: aCategory.
		
	methodSpy := S2Method subclass: (profilerName, 'Method') asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: aCategory.
	
	classSpy := S2Class subclass: (profilerName, 'Class') asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: aCategory.

	packageSpy := S2Package subclass: (profilerName, 'Package') asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: aCategory.
		
	profiler class compile: 'spyClassForPackage', String cr, String tab, ' ^ ', packageSpy name classified: 'hooks'.
	packageSpy class compile: 'spyClassForClass', String cr, String tab, ' ^ ', classSpy name classified: 'hooks'.
	classSpy class compile: 'spyClassForMethod', String cr, String tab, ' ^ ', methodSpy name classified: 'hooks'.
	methodSpy compile: 'beforeRun: methodName with: listOfArguments in: receiver
	"This method is executed before each method of the profiled application.
	 Insert here the instrumentation you would like to perform during the profiling."' classified: 'hooks'.
	profiler compile: 'registryName', String cr, String tab, '^ #', profilerName classified: 'hooks'. 
	
	test := AbstractS2pyTest subclass: (profilerName, 'Test') asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: aCategory.
	test compile: 'profilerClass', String cr, String tab,  '^  ', profilerName asSymbol classified: 'hooks'.

	self generateVisualizationTemplateOn: profiler! !

!S2pyCopy class methodsFor: 'util' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:44'!
generateVisualizationTemplateOn: profilerClass
	profilerClass compile: 'visualizeOn: view
	"This is a generated visualization"
	| allClasses  classShapeBuilder methodShapeBuilder  interactionBuilder classElements|
	interactionBuilder := self getInteractionBuilder.
	classShapeBuilder := self getClassShapeBuilder.
	methodShapeBuilder := self getMethodShapeBuilder.
	classElements := RTGroup new. 
	allClasses := self allClasses.
	allClasses do: [ :each | |mths classElement|
		classElement := (classShapeBuilder elementOn: each).
		view add: classElement.
		mths := (methodShapeBuilder elementsOn: each methods).
		view addAll: mths.
		RTGridLayout on: mths.
		mths @ RTDraggable @ RTPopup.
		RTNest new on: classElement nest: mths.
		classElement @ RTDraggable.
		classElements add: classElement.
		interactionBuilder setUpElements: mths.			
	].
	interactionBuilder setUpElements: classElements.
	RTGridLayout on: classElements
	' classified: 'visualization'! !

!S2pyCopy methodsFor: 'buttons' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:44'!
exportHTMLButton: view
	view addMenu: 'export as HTML' callback: [ RTHTMLExporter interactiveExportViewAsHTML: view ].! !

!S2pyCopy methodsFor: 'buttons' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:44'!
exportSVGButton: view
	view addMenu: 'export as SVG' callback: [ RTSVGExporter interactiveExportViewAsSVG: view ].! !

!S2pyCopy methodsFor: 'buttons' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:44'!
findButton: view
	|element|
	view addMenu: 'Find' callback: [  
		element := UIManager default chooseFrom: (view elements collect: #model) values: view elements.
		element notNil
			ifTrue: [ view canvas camera translateTo: element position. RTBlink on: element ] ].! !

!S2pyCopy methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:44'!
initializeView: builder
	"add buttons"
	self findButton: builder view.
	self zoomInButton: builder view.
	self zoomOutButton: builder view.
	self exportSVGButton: builder view.
	self exportHTMLButton: builder view.

	self runTestButtonOn: builder view.
	self refreshViewButtonOn: builder view.
	! !

!S2pyCopy methodsFor: 'buttons' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:44'!
refreshViewButtonOn: view
	view  addMenu: 'Refresh' callback: [
		| rawView |
		rawView := RTView new @ RTDraggableView.
		"builder := RTMondrianViewBuilder new view: rawView. "
		self visualizeOn: rawView.
		"builder applyLayout."].! !

!S2pyCopy methodsFor: 'buttons' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:44'!
runTestButtonOn: view
	view  addMenu: 'Run tests' callback: [ | sunitclasses |
		sunitclasses := (RPackage organizer packageOf: self class)  classesAndMetaClasses select: [:cls | cls inheritsFrom: TestCase ].
		sunitclasses do: [ :c | c new run]
		].! !

!S2pyCopy methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:44'!
visualize 
	| view |
	view := RTView new @ RTDraggableView.
	self initializeView: view.
	self visualizeOn: view.
	^ view open! !

!S2pyCopy methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:44'!
visualizeOn: view
	self subclassResponsibility! !

!S2pyCopy methodsFor: 'buttons' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:44'!
zoomInButton: view
	view addMenu: 'Zoom in' callback: [ RTZoomInMove on: view ].! !

!S2pyCopy methodsFor: 'buttons' stamp: 'AlvaroJosePeraltaOcampo 8/4/2014 06:44'!
zoomOutButton: view
	view addMenu: 'Zoom out' callback: [ RTZoomOutMove on: view ].! !
